//+------------------------------------------------------------------+
//|                                               TestCIndCopies.mq5 |
//|                        Copyright 2018, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2018, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property indicator_chart_window
#include <Canvas\iCanvas.mqh> // https://www.mql5.com/ru/code/22164
#include <Copies.mqh>
input string str = "Name1"; //Name

CIndCopies ind("test");
int OnInit() {
   Draw();
   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[]) {
   return(rates_total);
}
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long& lparam,
                  const double& dparam,
                  const string& sparam)  {
   if (id==CHARTEVENT_CHART_CHANGE) {
   ind.ReNew();
   Draw();
   }
}
//+------------------------------------------------------------------+
void Draw() {
   Canvas.Erase(0x00FFFFFF);
   int d=W.Height/(ind.N);
   Canvas.FillRectangle(0,ind.I*d,W.Width-1,(ind.I+1)*d,Canvas.Grad((double)ind.I/(ind.N+1))&0x80FFFFFF);
   int fontSize=W.Height/(ind.N+2);
   string text = str+": " + ind.str+", I="+string(ind.I)+", N="+string(ind.N);
   int w,h;
   Canvas.CurentFont("Tahoma",fontSize);
   Canvas.TextSize(text,w,h);
   Canvas.CurentFont("Tahoma",int(fontSize*W.Width*0.9/w));
   _CommXY(int(0.05*W.Width),ind.I*d,str+": " + ind.str+", I="+string(ind.I)+", N="+string(ind.N));
   Canvas.Update();
}
//+------------------------------------------------------------------+
